<?php
// +----------------------------------------------------------------------+
// | Copyright (c) SiouxApp                                               |
// +----------------------------------------------------------------------+
class SudoApache {
    private static $__NeedReload = false;
    private static $__NeedRestart = false;
    private static $__ModuleList = '';
    private static $__ApacheVersion = '';
    // --------------------------------------------------------------------
    public static function __constructStatic() {
        // PATH_ETC
        $files = array(PATH_ETC.'.htuserpasswd', PATH_ETC.'/.htsiteapp');
        foreach($files as $file){
            if(!file_exists($file)){
                UtilPath::FilePutContents($file, "\n");
            }
        }
    }
    // --------------------------------------------------------------------
    public static function ModuleRefresh() {
        $apps = ServerPackage::ArrayAppGet('all');
        $modules = array();
        $modules[] = 'auth_basic';
        $modules[] = 'authn_file';
        $modules[] = 'authz_groupfile';
        $modules[] = 'authz_user';
        $modules[] = 'php5';
        $modules[] = 'rewrite';  // TODO not needed?
        $modules[] = 'ssl';
        $modules[] = (in_array('Svn', $apps)) ? 'dav_svn' : '';
        $modules[] = (in_array('Redmine', $apps)) ? 'passenger' : '';
        $modules[] = (in_array('Trac', $apps)) ? 'python' : '';
        // $modules[] = (in_array('Trac', $packages)) ? 'trac' : '';
        foreach($modules as $module){
            if(empty($module))
                continue;
            if(self::__ModuleCheck($module)==false){
                $rc = self::__ModuleEnable($module);
                if($rc===false){
                    UtilLog::Error(__CLASS__, __METHOD__, E_USER_ERROR, "Apache: module not loaded: $module");
                }else{
                    self::$__NeedRestart = true;
                }
            }
        }
    }
    // --------------------------------------------------------------------
    public static function ConfigRefresh() {
        // apache2.conf
        $if24 = (self::VersionGet()>=2.4) ? '' : '# ';
        $str = "<Directory '".PATH_WWW."'>\n"
                ."  AllowOverride All\n"
                ."  Order allow,deny\n"
                ."  Allow from all\n"
                ."  {$if24}Require all granted\n"
                ."</Directory>\n"
                ."Alias ".UtilPathWww::UrlRootGet().".public/ ".PATH_OPT."sapp-common/public/\n"
                ."Alias ".UtilPathWww::UrlRootGet()."index.html ".PATH_OPT."sapp-common/public/page/pageredirect123.php\n"
                ."\n"
                ."<Directory '".PATH_DATA."'>\n"
                ."  AllowOverride All\n"
                ."  Order allow,deny\n"
                ."  Allow from all\n"
                ."  {$if24}Require all granted\n"
                ."</Directory>\n"
                ."\n"
                ."<Directory '".PATH_OPT."sapp-common/public/'>\n"
                ."  AllowOverride All\n"
                ."  Order allow,deny\n"
                ."  Allow from all\n"
                ."  {$if24}Require all granted\n"
                ."</Directory>\n"
                ."\n"
                ."\n";
        if(@file_get_contents(PATH_APACHE.'apache2.conf')!==$str){
            UtilPath::FilePutContents(PATH_APACHE.'apache2.conf', $str);
            self::$__NeedReload = true;
        }
        // package install-status refresh
        ServerPackage::Refresh();
        // conf.d -> site/app exists?
        foreach(scandir(PATH_APACHE) as $dirfile){
            if(substr($dirfile, 0, 1)=='.')
                continue;
            if($dirfile=='apache2.conf')
                continue;
            if(is_file(PATH_APACHE.$dirfile)){
                unlink(PATH_APACHE.$dirfile);
            }
            if(is_dir(PATH_APACHE.$dirfile)){
                if(in_array(ucfirst($dirfile), ServerPackage::ArrayAppGet('all'))){
                    foreach(scandir(PATH_APACHE.$dirfile) as $file){
                        if(substr($file, 0, 1)=='.')
                            continue;
                        $datapath = PATH_DATA.substr($file,0,strpos($file,'-')).'/'.substr($file,strpos($file,'-')+1);
                        if(file_exists($datapath))
                            continue;
                        unlink(PATH_APACHE.$dirfile.'/'.$file);
                        self::$__NeedReload = true;
                    }
                }else{
                    foreach(scandir(PATH_APACHE.$dirfile) as $val){
                        if(substr($val, 0, 1)=='.')
                            continue;
                        unlink(PATH_APACHE."$dirfile/$val");
                    }
                    rmdir(PATH_APACHE.$dirfile);
                }
            }
        }
        // site/app -> conf.d
        foreach(scandir(PATH_DATA) as $site){
            if(substr($site, 0, 1)=='.')
                continue;
            foreach(scandir(PATH_DATA.$site) as $app){
                if(substr($app, 0, 1)=='.')
                    continue;
                $dowrite = false;
                $confstr = (file_exists(PATH_DATA."$site/$app/.htapache.config.gen")) ? file_get_contents(PATH_DATA."$site/$app/.htapache.config.gen") : '';
                $confstr .= (file_exists(PATH_DATA."$site/$app/.htapache.configpro.gen")) ? file_get_contents(PATH_DATA."$site/$app/.htapache.configpro.gen") : '';
                $appclass = strtolower(UtilPathData::AppClassGet("$site/$app"));
                if(!in_array(ucfirst($appclass), ServerPackage::ArrayAppGet('all'))){
                    continue;
                }
                if(!file_exists(PATH_APACHE."$appclass/$site-$app"))
                    $dowrite = true;
                elseif(file_get_contents(PATH_APACHE."$appclass/$site-$app")!=$confstr)
                    $dowrite = true;
                if($dowrite){
                    if(empty($confstr)){
                        if(file_exists(PATH_APACHE."$appclass/$site-$app")){
                            unlink(PATH_APACHE."$appclass/$site-$app");
                            self::$__NeedReload = true;
                        }
                    }else{
                        @UtilPath::RMkdir(PATH_APACHE.$appclass);
                        UtilPath::FilePutContents(PATH_APACHE."$appclass/$site-$app", $confstr);
                        self::$__NeedReload = true;
                    }
                }
            }
        }
    }
    // --------------------------------------------------------------------
    public static function ServiceRefresh() {
        if(self::$__NeedRestart==true or self::$__NeedReload==true){
            if(self::$__NeedRestart==true){
                SudoApacheExec::Exec('apache-restart');
                self::$__NeedReload = false;
                self::$__NeedRestart = false;
            }elseif(self::$__NeedReload==true){
                SudoApacheExec::Exec('apache-reload');
                self::$__NeedReload = false;
            }
            self::__Status2Log();
        }
    }
    // --------------------------------------------------------------------
    public static function TermReload() {
        self::$__NeedReload = true;
    }
    // --------------------------------------------------------------------
    public static function ConfigCheck() {
        ob_start();
        SudoApacheExec::Exec('apache-configtest', '2>&1');
        $output = ob_get_clean();
        if(stripos($output, 'OK')===false){
            echo $output;
            return false;
        }
        return true;
    }
    // --------------------------------------------------------------------
    public static function VersionGet() {
        if(empty(self::$__ApacheVersion)){
            ob_start();
            SudoApacheExec::Exec('apache-version');
            $str = ob_get_clean();
            $version = 2.0;
            $version = (strpos($str, 'Apache/2.1')!==false) ? 2.1 : $version;
            $version = (strpos($str, 'Apache/2.2')!==false) ? 2.2 : $version;
            $version = (strpos($str, 'Apache/2.3')!==false) ? 2.3 : $version;
            $version = (strpos($str, 'Apache/2.4')!==false) ? 2.4 : $version;
            $version = (strpos($str, 'Apache/2.5')!==false) ? 2.5 : $version;
            $version = (strpos($str, 'Apache/2.6')!==false) ? 2.6 : $version;
            $version = (strpos($str, 'Apache/2.7')!==false) ? 2.7 : $version;
            $version = (strpos($str, 'Apache/2.8')!==false) ? 2.8 : $version;
            $version = (strpos($str, 'Apache/2.9')!==false) ? 2.9 : $version;
            self::$__ApacheVersion = $version;
        }
        return self::$__ApacheVersion;
    }
    ///////////////////////////////////////////////////////////////////////
    private static function __ModuleCheck($inModule) {
        if(empty(self::$__ModuleList)){
            ob_start();
            SudoApacheExec::Exec('apache-module-list', '2>&1');
            $output = ob_get_clean();
            self::$__ModuleList = $output;
        }
        return (strpos(self::$__ModuleList, $inModule.'_')===false) ? false : true;
    }
    // --------------------------------------------------------------------
    private static function __ModuleEnable($inModule) {
        ob_start();
        SudoApacheExec::Exec('apache-module-enable', "$inModule 2>&1");
        $output = ob_get_clean();
        if(stripos($output, 'ERROR')!==false){
            echo $output;
            return false;
        }
        return true;
    }
    // --------------------------------------------------------------------
    private static function __Status2Log() {
        if(self::$__NeedRestart){
            Exec::IfExec('ProUtilLog::Append', array("apache-status: restart required."));
        }
        if(self::$__NeedReload){
            Exec::IfExec('ProUtilLog::Append', array("apache-status: reload required."));
        }
    }
    
    // --------------------------------------------------------------------
}
?>